#!/usr/bin/perl

# ATTTTTTTTTTTTTTCTTG

$|=1;
use strict;
use CGI qw(:standard); 
use CGI::Carp ('fatalsToBrowser');

use ePOSSUM;
my $cgi=new CGI;
my $output=new ePOSSUM;
my %out;
my %FORM=$cgi->Vars();

foreach my $key (keys %FORM) {
	$FORM{$key}=~s/^\s//;
	$FORM{$key}=~s/\s$//;
}

$FORM{name}='test';
my $filename="ePOSSUM_temp_".($FORM{name}?$FORM{name}.'_':'').time()."_".int(rand(100000));
$out{html_output}=$filename.'.html';
my $html_target='/temp/'.$out{html_output};

$out{tfs}=($FORM{all_tf}?'all':join (",",grep s/^tf_//, keys %FORM));
my @errors=();

$FORM{coordinates}=~s/^Chr//i;
$FORM{coordinates}=~s/^X:/23/;
$FORM{coordinates}=~s/^Y:/24/;
$FORM{coordinates}=~s/^MT*:/0/;
push @errors,("No wild-type sequence or genomic position entered") unless $FORM{wildtype} or $FORM{coordinates};
push @errors,("If you want to analyse position and sequence, please use the 'variant' field.") if ($FORM{coordinates} and ($FORM{wildtype} or $FORM{variant}) ) ;
if ($FORM{'known_tfbs'}) {
	push @errors,("You must make up your mind - ePOSSUM can scan either known TFBS <i>or</i> TFBS for selected TFs.") if $out{tfs} ;
	push @errors,("ePOSSUM cannot scan known TFBS at a position without knowing the position, can we?") unless $FORM{coordinates} ;
	$out{tfs}='known';	
}
push @errors,("No TF(s) selected!") unless $out{tfs};
# die ($out{tfs});

if ($FORM{coordinates}) {
#	if ($FORM{coordinates}=~/^(\d+):(\d+)-(\d+)/){ 
#		@out{qw /chr start end/}=($1,$2,$3);  #/
#	}
	if ($FORM{coordinates}=~/^(\d+):(\d+)(.*?)>(.*)/) {  #/
		@out{qw /chr start old new/}=($1,$2,$3,$4);
	}
	else {
		push @errors,("Genomic position not in the correct format: ". $FORM{coordinates});
	}
	#delete $FORM{coordinates};
}

$out{wt}=uc $FORM{wildtype};
$out{mt}=uc $FORM{variant};

push @errors,("Illegal bases in wild-type sequence: $out{wt}") if $out{wt} and  $out{wt}!~/^[ACGT]+$/;
push @errors,("Illegal bases in variant sequence: $out{mt}") if $out{mt} and  $out{mt}!~/^[ACGT]+$/;
$output->PegOut('Cannot commence search',@errors) if @errors;
$output->StartOutput("Search for TFBSs...",{refresh=>[$html_target,5],});
#print "Content-Type: text/html\n\n";

my $cmd="/usr/bin/perl /www/ePOSSUM/cgi-bin/PredictTFBSquot.pl ".join (" ",map {"$_=$out{$_}"} keys %out);
print qq !Selected TFs: $out{tfs}<br>\n!;
print qq !Wild-type sequence: $out{wt}<br>\n!;
print qq !Variant sequence: $out{mt}<br>\n!;
print qq !Genomic position: !.$FORM{coordinates}."<br>\n";
print qq !<h3 class="red">DON'T TRY TO RELOAD THIS PAGE, USE THE HYPERLINK BELOW INSTEAD</h3>\n!; #'
print qq !<A HREF="$html_target">see status</A>\n!;
#print "$cmd<br>";
print "</body></html>\n\n";

close (STDOUT);
close (STDIN);
undef $output;


system ($cmd);

exit 0;