#!/usr/bin/perl

# ATTTTTTTTTTTTTTCTTG

$|=1;
use strict;
use CGI qw(:standard); 
use CGI::Carp ('fatalsToBrowser');

use ePOSSUM;
my $cgi=new CGI;
my $output=new ePOSSUM;
my %global_out;
my %FORM=$cgi->Vars();

foreach my $key (keys %FORM) {
	$FORM{$key}=~s/^\s+//;
	$FORM{$key}=~s/\s+$//;
}

my $filename="ePOSSUM_temp_".($FORM{name}?$FORM{name}.'_':'').time()."_".int(rand(100000));
$global_out{html_output}=$filename.'.html';
$global_out{data}=$filename.'.data';
my $html_target='/temp/'.$global_out{html_output};
my $data_target='/data/tmp/'.$global_out{data};

$global_out{tfs}=($FORM{all_tf}?'all':join (",",grep s/^tf_//, keys %FORM));
my @errors=();


push @errors,("No sequences or genomic positions entered") unless $FORM{sequences} or $FORM{variants};
push @errors,("If you want to analyse position and sequence, please use the 'variant' field.") if ($FORM{coordinates} and ($FORM{sequences}) ) ;
if ($FORM{'known_tfbs'}) {
	push @errors,("You must make up your mind - ePOSSUM can scan either known TFBS <i>or</i> TFBS for selected TFs.") if $global_out{tfs} ;
	push @errors,("ePOSSUM cannot scan known TFBS at a position without knowing the position, can we?") unless $FORM{variants} ;
	$global_out{tfs}='known';	
}
push @errors,("No TF(s) selected!") unless $global_out{tfs};

my $line=1;
my @data=();
my %done=();
foreach my $variant (split /\n/, uc $FORM{variants}) {
	$variant=~s/\s+//g;
	$variant=~s/^Chr//i;
	$variant=~s/^X:/23/;
	$variant=~s/^Y:/24/;
	$variant=~s/^MT*:/0/;
	if ($variant=~/^(\d+):(\d+)(.*?)>(.*)/) {  #/
	#	@local_out{qw /chr start old new/}=($1,$2,$3,$4);
	#	my $var=join ("|",@local_out{qw /chr start old new/});
		if ($done{$variant}) {
			push @errors, "Variant $variant duplicated (lines $line / $done{$variant}).";
		}
		else {
			$done{$variant}=$line;
			push @data,['','',$variant];
		}
	}
	else {
		push @errors, "Genomic position not in the correct format: $variant (line $line).";
	}
	$line++;
	if ($line>100) {
		push @errors,"We cannot handle more than 100 variants.";
		last;
	}
}

$line=1;
foreach my $sequence_pair (split /\n/,uc $FORM{sequences}) {
	$sequence_pair=~s/^\s+//;
	my ($wt,$mt)=(split /\s+/,$sequence_pair);
	push @errors,("Illegal bases in wild-type sequence: $wt (line $line).") if $wt and  $wt!~/^[ACGT]+$/;
	push @errors,("Illegal bases in variant sequence: $mt (line $line).") if $mt and  $mt!~/^[ACGT]+$/;
	my $var=join ("|",$wt,$mt);
	if ($done{$var}) {
		push @errors, "Sequence pair duplicated (lines $line / $done{$var}).";
	}
	else {
		$done{$var}=$line;
		push @data,[$wt,$mt,''];
	}
	$line++;
	if ($line>100) {
		push @errors,"We cannot handle more than 100 variants.";
		last;
	}	
}




$output->PegOut('Cannot commence search',@errors) if @errors;
open (OUT,'>',$data_target) || $output->PegOut('Cannot commence search','file error',$!);
#$output->StartOutput("Search for TFBSs...");
$output->StartOutput("Search for TFBSs...",{refresh=>[$html_target,5],});
#print "Content-Type: text/html\n\n";
my $cmd="/usr/bin/perl /www/ePOSSUM/cgi-bin/SearchTFBS_batch.pl ".$filename;
print qq !<h3 class="red">DON'T TRY TO RELOAD THIS PAGE, USE THE HYPERLINK BELOW INSTEAD</h3>\n!; #'
print qq !<A HREF="$html_target">see status</A><br>\n!;

print qq !Selected TFs: $global_out{tfs}<br>\n!;
print OUT "TF: ",$global_out{tfs},"\n";
print scalar @data," variants to analyse...<hr>";

print '<table border="0"><tr><td>wild-type sequence</td><td>variant sequence</td><td>genomic position</td></tr>';
foreach my $dataref (@data) {
	print "<tr><td>",join ("</td><td>",@$dataref),"</td></tr>\n";
	print OUT join ("\t",@$dataref),"\n";
}
print "</table>\n";
close OUT;



#print "$cmd<br>";
print "</body></html>\n\n";

close (STDOUT);
close (STDIN);
undef $output;


system ($cmd);

exit 0;