use strict;
package ePOSSUM;

our @EXPORT=qw (die PegOut);
use base qw(Exporter);
use DBI;


my $www_output_open=0;

sub new {
	my $class = shift;
	my $objectref = shift || {};
	bless $objectref, $class;
	return $objectref;
}

sub die {
	my $self=shift;
	if ($self->{www_output_open}){
		$self->PegOut('Error',{text=>[@_]});
	}
	else {
		die (@_);
	}
	# overload shell-based die
}


sub StartOutput {
	my $self=shift;
	$self->{www_output_open}=1;
	my $title=shift;
	my $header_title=$title;
	$header_title=~s/<.*?>//g;
	my $options=shift;
	my $refresh='';
	if (ref $options->{refresh} eq 'ARRAY'){
		my $period=length $options->{refresh}->[1]?$options->{refresh}->[1]:5;
		$refresh=qq!<meta http-equiv="refresh" content="$period; URL=$options->{refresh}->[0]">!;
	}
	elsif ($options->{refresh}){
		$refresh=qq!<meta http-equiv="refresh" content="2; URL=$options->{refresh}">!;
	}


	if ($options->{filename}){
		open (STDOUT,'>',$options->{filename}) || PegOut("Could not write to output file $options->{filename}",{list=>[$!]});
	#	open (STDERR,'>>',$options->{filename}) || PegOut("Could not write to output file $options->{filename}",{list=>[$!]});
	}
	else {
		print "Content-Type: text/html\n\n";
	}
	print <<EndHeader

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
<TITLE>$header_title</TITLE>
<link rel="icon" href="/HomozygosityMapper/HM_favicon.png" type="image/png">
$refresh
<STYLE type="text/css">
<!--
body {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12pt;
}
td {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 10pt;
	vertical-align: top;

}
#table {
 #   border-collapse: collapse;
  #  border: 1px solid black;
#}
.bold {
	font-weight: bold;
}
.red {
	color: red;
}
.blue {
	color: blue;
}
.green {
	color: green;
}
.darkgrey {
	color: #999999;
}
.yellow {
	color: yellow;
}
.violet {
	color: violet;
}
.grey {
	color: #CCCCCC;
}
.small {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 8pt;
	vertical-align: top;
}
.redbg {
	background-color: red;
}
.bluebg {
	background-color: blue;
}
a {
	color: blue;
}
a:visited {
	color: blue;
}
h2 {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 18pt;
}
h1 {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 24pt;
}
.code {
	font-family: "Courier New", Courier, mono;
}
.input_field {	
	width: 110pt; 
}
EndHeader
;
	if ($options->{styles}){
		print ${$options->{styles}};
	}
	print qq!
	-->
	</STYLE>\n!;
	if ($options->{css}){
		print qq!<link href="$options->{css}" rel="stylesheet" type="text/css">\n!;
	}
	my $bodytext=$options->{body} || '';
	print "</head><body>";
	if ($options->{Subtitle}){
		print qq *
	<table align="center" cellpadding="5" width="600">
  <tbody>
  <tr>
      <td>
	  <h1 align="center">$title</h1>
      <H2 align="center" style="line-height: 25pt; margin:0" class="blue">$options->{Subtitle}</H2></td>
    </tr>
  </tbody>
</table>
*
;
}
	

	unless ($options->{no_heading}){
		print "<H2>$title</H2>\n" unless $options->{Subtitle};
	}
}



sub PegOut {
	# HTML based variant of die
	my $self=shift;
	my $data=pop @_ if ref $_[-1] eq 'HASH'; # take hash ref out of @_
	my $title=shift || ''; # when there's something left, it must be a title
	my @data=@_;
	unless ($self->{www_output_open}){
	# calls StartOutput when it was not called before
		$self->StartOutput($title,{'no_heading'=>1});
	}
	print qq!<h2 class="red">$title</h2>\n! if $title;
	if (ref $data->{list} eq 'ARRAY' and @{$data->{list}}){
		print "<ul>\n";
		foreach my $line (@{$data->{list}}){
			print "<li>$line</li>\n";
		}
		print "</ul>\n";
	}
	if (ref $data->{text} eq 'ARRAY' and @{$data->{text}}){
		print join ("<br>",
			map {
				s /\n/<br>/g;
				s/\t/ /g;
			$_ }
		@{$data->{text}});
	}
	if (@data){
		print join ("<br>",
			map {
				s /\n/<br>/g;
				s/\t/ /g;
			$_ }  @data);
	}
	EndOutput();
}

sub timestamp {
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                             localtime(time);
	return sprintf ("%4d%02d%02d",$year+1900,$mon+1,$mday);
}

sub EndOutput {
	print "</BODY></HTML>\n";
	close STDOUT;
	exit 0;
}


sub Connect {
	my $dbh =  DBI->connect( "dbi:Pg:dbname=postgres", "login", "passwd",
		{ AutoCommit => 0, RaiseError => 0 } )
  		|| die2($DBI::errstr);
  return $dbh;
}

return 1;